| MINI55_BSP V3.01.003 The Board Support Package for Mini55 Series MCU

Macros | Functions
I2C Exported Functions
MINI55 Device Driver » I2C Driver » I2C Exported Constants
Collaboration diagram for I2C Exported Functions:

## Macros
#define | I2C_SET_CONTROL_REG(i2c, u8Ctrl) ( (i2c)->CTL = ((i2c)->CTL & ~0x3c) | u8Ctrl )
| This macro sets the I2C control register at one time. More...
#define | I2C_START(i2c) ( (i2c)->CTL = ((i2c)->CTL & ~I2C_CTL_SI_Msk) | I2C_CTL_STA_Msk )
| This macro only set START bit to the control register of I2C module. More...
#define | I2C_WAIT_READY(i2c) while(!((i2c)->CTL & I2C_CTL_SI_Msk))
| This macro will return when I2C module is ready. More...
#define | I2C_DISABLE_FIFO(i2c) ( (i2c)->CTL1 &= ~I2C_CTL1_FIFOEN_Msk )
| This macro disables the FIFO function. More...
#define | I2C_ENABLE_FIFO(i2c) ( (i2c)->CTL1 |= I2C_CTL1_FIFOEN_Msk )
| This macro enables the FIFO function. More...
#define | I2C_DISABLE_CLOCK_STRETCH(i2c) ( (i2c)->CTL1 |= I2C_CTL1_NSTRETCH_Msk )
| This macro disables clock stretch function. More...
#define | I2C_ENABLE_CLOCK_STRETCH(i2c) ( (i2c)->CTL1 &= ~I2C_CTL1_NSTRETCH_Msk )
| This macro enables clock stretch function. More...
#define | I2C_DISABLE_OVERRUN_INT(i2c) ( (i2c)->CTL1 &= ~I2C_CTL1_OVIEN_Msk )
| This macro disables over-run interrupt. More...
#define | I2C_ENABLE_OVERRUN_INT(i2c) ( (i2c)->CTL1 |= I2C_CTL1_OVIEN_Msk )
| This macro enables over-run interrupt. More...
#define | I2C_ENABLE_UNDERRUN_INT(i2c) ( (i2c)->CTL1 |= I2C_CTL1_URIEN_Msk )
| This macro enables under-run interrupt. More...
#define | I2C_DISABLE_UNDERRUN_INT(i2c) ( (i2c)->CTL1 &= ~I2C_CTL1_URIEN_Msk )
| This macro disables under-run interrupt. More...
#define | I2C_GET_DATA(i2c) ( (i2c)->DAT )
| This macro returns the data stored in data register of I2C module. More...
#define | I2C_SET_DATA(i2c, u8Data) ( (i2c)->DAT = u8Data )
| This macro writes the data to data register of I2C module. More...
#define | I2C_GET_STATUS(i2c) ( (i2c)->STATUS )
| This macro returns the status of I2C module. More...
#define | I2C_GET_TIMEOUT_FLAG(i2c) ( ((i2c)->TOCTL & I2C_TOCTL_TOIF_Msk) == I2C_TOCTL_TOIF_Msk ? 1:0 )
| This macro returns timeout flag. More...
#define | I2C_GET_WAKEUP_FLAG(i2c) ( ((i2c)->STATUS1 & I2C_STATUS1_WKIF_Msk) == I2C_STATUS1_WKIF_Msk ? 1:0 )
| This macro returns wakeup flag. More...
#define | I2C_CLEAR_WAKEUP_FLAG(i2c) ( (i2c)->STATUS1 = I2C_STATUS1_WKIF_Msk )
| This macro clears wakeup flag. More...

## Functions
static __INLINE void | I2C_STOP (I2C_T *i2c)
| This macro only set STOP bit to the control register of I2C module. More...
uint32_t | I2C_Open (I2C_T *i2c, uint32_t u32BusClock)
| This function make I2C module be ready and set the wanted bus clock. More...
void | I2C_Close (I2C_T *i2c)
| This function closes the I2C module. More...
void | I2C_ClearTimeoutFlag (I2C_T *i2c)
| This function clears the timeout flag. More...
void | I2C_Trigger (I2C_T *i2c, uint8_t u8Start, uint8_t u8Stop, uint8_t u8Si, uint8_t u8Ack)
| This function sets the control bit of the I2C module. More...
void | I2C_DisableInt (I2C_T *i2c)
| This function disables the interrupt (EI bit) of I2C module. More...
void | I2C_EnableInt (I2C_T *i2c)
| This function enables the interrupt (EI bit) of I2C module. More...
uint32_t | I2C_GetBusClockFreq (I2C_T *i2c)
| This function returns the real bus clock of I2C module. More...
uint32_t | I2C_SetBusClockFreq (I2C_T *i2c, uint32_t u32BusClock)
| This function enables the interrupt (EI bit) of I2C module. More...
uint32_t | I2C_GetIntFlag (I2C_T *i2c)
| This function gets the interrupt flag (SI bit) of I2C module. More...
uint32_t | I2C_GetStatus (I2C_T *i2c)
| This function returns the status of I2C module. More...
uint32_t | I2C_GetData (I2C_T *i2c)
| This function returns the data stored in data register of I2C module. More...
void | I2C_SetData (I2C_T *i2c, uint8_t u8Data)
| This function writes the data to data register of I2C module. More...
void | I2C_SetSlaveAddr (I2C_T *i2c, uint8_t u8SlaveNo, uint8_t u8SlaveAddr, uint8_t u8GCMode)
| Configure slave address and enable GC mode. More...
void | I2C_SetSlaveAddrMask (I2C_T *i2c, uint8_t u8SlaveNo, uint8_t u8SlaveAddrMask)
| Configure the mask of slave address. The corresponding address bit is "Don't Care". More...
void | I2C_EnableTimeout (I2C_T *i2c, uint8_t u8LongTimeout)
| This function enables timeout function and configures DIV4 function to support long timeout. More...
void | I2C_DisableTimeout (I2C_T *i2c)
| This function disables timeout function. More...
void | I2C_EnableWakeup (I2C_T *i2c)
| This function enables the wakeup function of I2C module. More...
void | I2C_DisableWakeup (I2C_T *i2c)
| This function disables the wakeup function of I2C module. More...

## Detailed Description

## Macro Definition Documentation

## ◆ I2C_CLEAR_WAKEUP_FLAG

#define I2C_CLEAR_WAKEUP_FLAG | ( |  | i2c | ) | ( (i2c)->STATUS1 = I2C_STATUS1_WKIF_Msk )

This macro clears wakeup flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 193 of file i2c.h.

## ◆ I2C_DISABLE_CLOCK_STRETCH

#define I2C_DISABLE_CLOCK_STRETCH | ( |  | i2c | ) | ( (i2c)->CTL1 |= I2C_CTL1_NSTRETCH_Msk )

This macro disables clock stretch function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 111 of file i2c.h.

## ◆ I2C_DISABLE_FIFO

#define I2C_DISABLE_FIFO | ( |  | i2c | ) | ( (i2c)->CTL1 &= ~I2C_CTL1_FIFOEN_Msk )

This macro disables the FIFO function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 97 of file i2c.h.

## ◆ I2C_DISABLE_OVERRUN_INT

#define I2C_DISABLE_OVERRUN_INT | ( |  | i2c | ) | ( (i2c)->CTL1 &= ~I2C_CTL1_OVIEN_Msk )

This macro disables over-run interrupt.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 125 of file i2c.h.

## ◆ I2C_DISABLE_UNDERRUN_INT

#define I2C_DISABLE_UNDERRUN_INT | ( |  | i2c | ) | ( (i2c)->CTL1 &= ~I2C_CTL1_URIEN_Msk )

This macro disables under-run interrupt.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 146 of file i2c.h.

## ◆ I2C_ENABLE_CLOCK_STRETCH

#define I2C_ENABLE_CLOCK_STRETCH | ( |  | i2c | ) | ( (i2c)->CTL1 &= ~I2C_CTL1_NSTRETCH_Msk )

This macro enables clock stretch function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 118 of file i2c.h.

## ◆ I2C_ENABLE_FIFO

#define I2C_ENABLE_FIFO | ( |  | i2c | ) | ( (i2c)->CTL1 |= I2C_CTL1_FIFOEN_Msk )

This macro enables the FIFO function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 104 of file i2c.h.

## ◆ I2C_ENABLE_OVERRUN_INT

#define I2C_ENABLE_OVERRUN_INT | ( |  | i2c | ) | ( (i2c)->CTL1 |= I2C_CTL1_OVIEN_Msk )

This macro enables over-run interrupt.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 132 of file i2c.h.

## ◆ I2C_ENABLE_UNDERRUN_INT

#define I2C_ENABLE_UNDERRUN_INT | ( |  | i2c | ) | ( (i2c)->CTL1 |= I2C_CTL1_URIEN_Msk )

This macro enables under-run interrupt.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 139 of file i2c.h.

## ◆ I2C_GET_DATA

#define I2C_GET_DATA | ( |  | i2c | ) | ( (i2c)->DAT )

This macro returns the data stored in data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Data.

Definition at line 153 of file i2c.h.

## ◆ I2C_GET_STATUS

#define I2C_GET_STATUS | ( |  | i2c | ) | ( (i2c)->STATUS )

This macro returns the status of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Definition at line 168 of file i2c.h.

## ◆ I2C_GET_TIMEOUT_FLAG

#define I2C_GET_TIMEOUT_FLAG | ( |  | i2c | ) | ( ((i2c)->TOCTL & I2C_TOCTL_TOIF_Msk) == I2C_TOCTL_TOIF_Msk ? 1:0 )

This macro returns timeout flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 177 of file i2c.h.

## ◆ I2C_GET_WAKEUP_FLAG

#define I2C_GET_WAKEUP_FLAG | ( |  | i2c | ) | ( ((i2c)->STATUS1 & I2C_STATUS1_WKIF_Msk) == I2C_STATUS1_WKIF_Msk ? 1:0 )

This macro returns wakeup flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 186 of file i2c.h.

## ◆ I2C_SET_CONTROL_REG

#define I2C_SET_CONTROL_REG | ( |  | i2c,
|  |  | u8Ctrl
| ) |  | ( (i2c)->CTL = ((i2c)->CTL & ~0x3c) | u8Ctrl )

This macro sets the I2C control register at one time.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Ctrl | is the register value of I2C control register.

Returns
  none

Definition at line 52 of file i2c.h.

## ◆ I2C_SET_DATA

#define I2C_SET_DATA | ( |  | i2c,
|  |  | u8Data
| ) |  | ( (i2c)->DAT = u8Data )

This macro writes the data to data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Data | is the data which will be write to data register of I2C module.

Returns
  none

Definition at line 161 of file i2c.h.

## ◆ I2C_START

#define I2C_START | ( |  | i2c | ) | ( (i2c)->CTL = ((i2c)->CTL & ~I2C_CTL_SI_Msk) | I2C_CTL_STA_Msk )

This macro only set START bit to the control register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 59 of file i2c.h.

## ◆ I2C_WAIT_READY

#define I2C_WAIT_READY | ( |  | i2c | ) | while(!((i2c)->CTL & I2C_CTL_SI_Msk))

This macro will return when I2C module is ready.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 90 of file i2c.h.

## Function Documentation

## ◆ I2C_ClearTimeoutFlag()

void I2C_ClearTimeoutFlag | ( | I2C_T * | i2c | ) |

This function clears the timeout flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 66 of file i2c.c.

## ◆ I2C_Close()

void I2C_Close | ( | I2C_T * | i2c | ) |

This function closes the I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 51 of file i2c.c.

## ◆ I2C_DisableInt()

void I2C_DisableInt | ( | I2C_T * | i2c | ) |

This function disables the interrupt (EI bit) of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 101 of file i2c.c.

## ◆ I2C_DisableTimeout()

void I2C_DisableTimeout | ( | I2C_T * | i2c | ) |

This function disables timeout function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none.

Definition at line 265 of file i2c.c.

## ◆ I2C_DisableWakeup()

void I2C_DisableWakeup | ( | I2C_T * | i2c | ) |

This function disables the wakeup function of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none.

Definition at line 285 of file i2c.c.

## ◆ I2C_EnableInt()

void I2C_EnableInt | ( | I2C_T * | i2c | ) |

This function enables the interrupt (EI bit) of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 111 of file i2c.c.

## ◆ I2C_EnableTimeout()

void I2C_EnableTimeout | ( | I2C_T * | i2c,
|  | uint8_t | u8LongTimeout
| ) |  |

This function enables timeout function and configures DIV4 function to support long timeout.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8LongTimeout | Enable timeout counter input clock is divide by 4.

Returns
  none.

Definition at line 250 of file i2c.c.

## ◆ I2C_EnableWakeup()

void I2C_EnableWakeup | ( | I2C_T * | i2c | ) |

This function enables the wakeup function of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none.

Definition at line 275 of file i2c.c.

## ◆ I2C_GetBusClockFreq()

uint32_t I2C_GetBusClockFreq | ( | I2C_T * | i2c | ) |

This function returns the real bus clock of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 121 of file i2c.c.

## ◆ I2C_GetData()

uint32_t I2C_GetData | ( | I2C_T * | i2c | ) |

This function returns the data stored in data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Data.

Definition at line 171 of file i2c.c.

## ◆ I2C_GetIntFlag()

uint32_t I2C_GetIntFlag | ( | I2C_T * | i2c | ) |

This function gets the interrupt flag (SI bit) of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Interrupt flag.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 151 of file i2c.c.

## ◆ I2C_GetStatus()

uint32_t I2C_GetStatus | ( | I2C_T * | i2c | ) |

This function returns the status of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Definition at line 161 of file i2c.c.

## ◆ I2C_Open()

uint32_t I2C_Open | ( | I2C_T * | i2c,
|  | uint32_t | u32BusClock
| ) |  |

This function make I2C module be ready and set the wanted bus clock.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u32BusClock | is the target bus speed of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 33 of file i2c.c.

## ◆ I2C_SetBusClockFreq()

uint32_t I2C_SetBusClockFreq | ( | I2C_T * | i2c,
|  | uint32_t | u32BusClock
| ) |  |

This function enables the interrupt (EI bit) of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u32BusClock | is the target bus speed of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 134 of file i2c.c.

## ◆ I2C_SetData()

void I2C_SetData | ( | I2C_T * | i2c,
|  | uint8_t | u8Data
| ) |  |

This function writes the data to data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Data | is the data which will be write to data register of I2C module.

Returns
  none

Definition at line 182 of file i2c.c.

## ◆ I2C_SetSlaveAddr()

void I2C_SetSlaveAddr | ( | I2C_T * | i2c,
|  | uint8_t | u8SlaveNo,
|  | uint8_t | u8SlaveAddr,
|  | uint8_t | u8GCMode
| ) |  |

Configure slave address and enable GC mode.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8SlaveNo | is the set number of salve address.
  [in] | u8SlaveAddr | is the slave address.
  [in] | u8GCMode | enable GC mode.

Returns
  none

Definition at line 195 of file i2c.c.

## ◆ I2C_SetSlaveAddrMask()

void I2C_SetSlaveAddrMask | ( | I2C_T * | i2c,
|  | uint8_t | u8SlaveNo,
|  | uint8_t | u8SlaveAddrMask
| ) |  |

Configure the mask of slave address. The corresponding address bit is "Don't Care".

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8SlaveNo | is the set number of salve address.
  [in] | u8SlaveAddrMask | is the slave address mask.

Returns
  none

Definition at line 223 of file i2c.c.

## ◆ I2C_STOP()

static __INLINE void I2C_STOP | ( | I2C_T * | i2c | ) |
| static

This macro only set STOP bit to the control register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 73 of file i2c.h.

## ◆ I2C_Trigger()

void I2C_Trigger | ( | I2C_T * | i2c,
|  | uint8_t | u8Start,
|  | uint8_t | u8Stop,
|  | uint8_t | u8Si,
|  | uint8_t | u8Ack
| ) |  |

This function sets the control bit of the I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Start | sets START bit to I2C module.
  [in] | u8Stop | sets STOP bit to I2C module.
  [in] | u8Si | sets SI bit to I2C module.
  [in] | u8Ack | sets ACK bit to I2C module.

Returns
  none

Definition at line 80 of file i2c.c.